<template>
  <v-form
    action="https://app.moosend.com/subscribe/8b3501ed-f635-40b2-b447-72905bec70d2"
    id="newsletterForm"
    lazy-validation
    method="post"
    ref="form"
    v-model="valid"
  >
    <v-text-field
      :rules="nameRules"
      label="Name*"
      name="ms-name"
      required
    ></v-text-field>

    <v-text-field
      :rules="emailRules"
      label="E-mail*"
      name="ms-email"
      required
    ></v-text-field>

    <v-text-field
      label="City"
      name="ms-City"
    ></v-text-field>

    <v-checkbox
      :rules="[v => !!v || 'You must agree to continue!']"
      label="Do you agree?*"
      v-model="checkbox"
      required
    >
      <template slot="label">
        <p>
          Yes, I would like to receive information about this product via email.
          I herewith agree that the provided details are shared with the thirdparty newsletter service <a href="//www.moosend.com/?utm_source=poweredby&utm_medium=forms&utm_campaign=ecoroutes.moosend.com">moosend</a>.
          For further information check their <a href="https://moosend.com/terms/">terms and services</a> and <a href="https://moosend.com/privacy-policy/">privacy policy</a>.*
        </p>
      </template>
    </v-checkbox>
    <input 
      name="ms-Consent"
      type="hidden"
      :value="checkbox ? 'true' : 'false'"
      required
    />

    <v-btn
      :disabled="!valid"
      color="success"
      class="mr-4"
      @click="validate"
    >
      Signup
    </v-btn>

    <small>* required fields</small>
  </v-form>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator';


type VueForm = Vue & { validate: () => boolean };


@Component
export default class NewsletterForm extends Vue {
  private valid = false;
  private nameRules = [
    (v: string) => !!v || 'Name is required',
  ];
  private emailRules = [
    (v: string) => !!v || 'E-mail is required',
    (v: string) => /.+@.+\..+/.test(v) || 'E-mail must be valid',
  ];
  private checkbox = false;

  public validate() {
    const vueForm = this.$refs.form as VueForm;
    if (vueForm.validate()) {
      const form = document.getElementById('newsletterForm') as HTMLFormElement;
      form.submit();
    }
  }
}
</script>
